// CrackUp.h : main header file for the CRACKUP application
//
// CrackUp version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition, November 3, 1998
// Written by Bob Flanders and Gregory A. Wolking

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

// Custom message IDs
#define MYWM_NOTIFYICON		(WM_APP + 1)
#define MYWM_SCANCOMPLETE	(WM_APP + 2)
#define MYWM_CHECKLEVELS	(WM_APP + 3)
#define MYWM_UPDATETIMELEFT	(WM_APP + 4)
#define MYWM_SHOWWARNING	(WM_APP + 5)

// Colors
#define	FRAGCOLOR			0x00ff0000				// FRAGCOLOR is light blue
#define UNFRAGCOLOR			0x00ffff20  			// UNFRAGCOLOR is cyan

/////////////////////////////////////////////////////////////////////////////
// CCrackUpApp:
// See CrackUp.cpp for the implementation of this class
//

class CCrackUpApp : public CWinApp
{
public:
	CCrackUpApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCrackUpApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CCrackUpApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// ************************************************************************
// Other application defines
// ************************************************************************

// #include <vwin32.h>

//    The <vwin32.h> header file is part of the Windows 95 DDK.
//    If you don't have the Windows 95 DDK, then use the definitions
//    below.

#ifndef VWIN32_DIOC_DOS_IOCTL					// q. ioctl defined?
#define VWIN32_DIOC_DOS_IOCTL 1					// a. no .. define it
#define VWIN32_DIOC_DOS_INT25 2					// .. and int 25 support (disk read)
#define	VWIN32_DIOC_DOS_DRIVEINFO 6				// .. and extended support (OSR2)

typedef struct _DIOC_REGISTERS					// register definitions
{
DWORD reg_EBX;									// EBX
DWORD reg_EDX;									// EDX
DWORD reg_ECX;									// ECX
DWORD reg_EAX;									// EAX
DWORD reg_EDI;									// EDI
DWORD reg_ESI;									// ESI 
DWORD reg_Flags;								// .. and flags
}
		DIOC_REGISTERS,							// structure definition
		*PDIOC_REGISTERS;						// and pointer to structure

#endif

// Intel x86 processor status flag
#define CARRY_FLAG  0x1


#pragma pack(1)									// these must be on byte boundaries
typedef struct _BPB								// bios parameter block structure
{
WORD    iBytesPerSector;						// Bytes per sector
BYTE    cSecsPerCluster;						// Sectors per cluster
WORD    iSecsReserved;							// Reserved sectors
BYTE    cFATs;									// FATs
WORD    iRootEntries;							// Root Directory Entries
WORD    iSectors;								// Total number of sectors in image
BYTE    bMediaDesc;								// Media descriptor
WORD    iSecsPerFAT;							// Sectors per FAT
WORD    iSecsPerTrack;							// Sectors per track
WORD    iHeads;									// Heads
DWORD   dwSecsHidden;							// Hidden sectors
DWORD   dwSecsTotal;							// Total sectors (iSectors zero)
DWORD	dwSecsPerFat;							// sectors per fat
WORD	iExtFlags;								// extended flags
WORD	iFSVersion;								// version of file system
DWORD	dwRootCluster;							// first root cluster
WORD	iFSInfoSec;								// file system information sector
WORD	iBkupBootSec;							// backup boot sector
BYTE    acReserved[6];							// reserved space
} 
			BPB,								// structure definition
			*PBPB;								// and pointer to structure

typedef struct _BOOTSECTOR						// format of boot sector
{
char	acJmp[3],								// jump around bpb
		acOem[8];								// oem name area
BPB		stBPB;									// bios param block
}
			BOOTREC,							// structure definition
		   *PBOOTREC;							// pointer to boot record

typedef struct _DISKIO							// disk IO structure
{
DWORD  dwStartSector;							// starting logical sector number
WORD   wSectors;								// number of sectors
BYTE  *lpBuffer;								// address of read/write buffer
} 
			DISKIO,								// structure definition
		   *PDISKIO;							// and pointer to structure

typedef	struct	_EA_DEVPARMS					// extended device parameters
{
BYTE	bSpecialFunctions;						// special function field
BYTE	bDeviceType;							// device type
WORD	iDeviceAttributes;						// device attributes
WORD	iCyls;									// cylinders on device
BYTE	bMediaType;								// media type of device
BPB		stBPB;									// BPB from device
BYTE	acReserved[32];							// reserved for later
WORD	iTrackTableEntries;						// number of tract table entries
BYTE	acSectorTable[1024];					// track table
}
			EA_DEVPARMS,						// structure definition
		   *PEA_DEVPARMS;						// and pointer to structure

typedef	struct	_DRVTABENT						// drive table entry
{
char	cDrv,									// drive letter
		cDrvNull;								// .. null for an ASCIIZ string
WORD	wFatType;								// fat type: FAT32 or FAT16
BYTE	acVolName[12];							// volume name
BPB		stBPB;									// bpb from drive
DWORD	dwClusters,								// number of clusters
		dwFiles,								// files on drive
		dwZero,									// zero-length files
		dwDirs,									// directories
		dwOK,									// non-fragged moveable files/dirs
		dwSysOK,								// non-fragged unmoveable files/dirs
		dwFrag,									// fragged moveable files/dirs
		dwSysFrag,								// fragged unmoveable files/dirs
		dwExtraFragments,						// fragments on drive
		dwClusInFrags,							// clusters in fragments
		dwClusUnFrags,							// clusters unfragmented
		dwBoundedFreeChunks,					// Number of "bounded" free "chunks"
		dwFreeChunks,							// Total free "chunks"
		dwBFreeClusters,						// "Bounded" free clusters
		dwUFreeClusters,						// "Unbounded" free clusters
		dwSystemFiles,							// # of unmoveable files
		dwSystemClusters,						// # of unmoveable clusters
		dwExtraSysFragments;					// # of "extra" fragments in system files.
float	fFragLvl;								// level of fragmentation
BOOL	bCheckDrive,							// check this drive if true
		bRptRdy;								// report ready
SYSTEMTIME stLastScan;							// Time of most recent scan.
}
			DRVTABENT,							// structure definition
		   *PDRVTABENT;							// and pointer to structure

typedef	struct	_DIRENT							// directory entry
{
BYTE	acName[8];								// file name
BYTE	acExt[3];								// file extension
BYTE	bAttr;									// attributes: see defines below
BYTE	bNT;									// NT flag
BYTE	bCreateTm[3];							// create time
WORD	wCreateDt;								// create date
WORD	wAccess;								// last access
WORD	wClusterH;								// high cluster bytes
WORD	wTime,									// time
		wDate,									// date
		wCluster;								// first cluster
DWORD	dwSize;									// size of file
}
			DIRENT,								// structure definition
		   *PDIRENT;							// pointer to an entry
#pragma pack()									// .. return to default packing

#define		DIRATTRARCH		0x20 				// ..1. .... Archive
#define		DIRATTRDIR		0x10 				// ...1 .... Directory
#define		DIRATTRVOLUME	0x08 				// .... 1... Volume label
#define		DIRATTRSYS		0x04 				// .... .1.. System
#define		DIRATTRHIDDEN	0x02 				// .... ..1. Hidden
#define		DIRATTRRO		0x01 				// .... ...1 Read only
#define		DIRVIRTENT		0x0f 				// .... 1111 Virtual entry
#define		SYSFILEATTR		0x06				// Hidden + system
#define		DIRDELETED		0xe5 				// first char if file deleted



#define			ERMTITLE		"CrackUp Error"
#define			ERMBADVERSION	"This program requires Windows 95 or Windows 98"
#define			ERMNODRIVES		"No valid drives detected"
#define			ERMNOMEM		"Out of memory"

#define			INITERR			255				
#define			ERRGENL			255				

#define			DEFVWIN32		"\\\\.\\VWIN32"			
			
#define			FSNAMESZ		20
#define			FATNAME			"FAT"
#define			FAT32			32
#define			FAT16			16
#define			UNKNOWN			0 
#define			FAT12CLUSTERS	4086

#define			DFLSECTORSZ		512

#define			NEWWINBUILD		1080				// Build # for OSR2

#define			DRVSTRLEN	((4*26)+1)				//length of drive string
													// 26 x 'd:/' string + null
#define			DRIVELEN	27						// length of drives string
#define			MAXDRIVES	26						// we can only do 26 drives max

#define			DFLTIME		4						// default to 4 hours
#define			TENSEC		10000					// millisecs per 10 seconds (one "tick")

typedef			unsigned char	UCHAR;

/////////////////////////////////////////////////////////////////////////////
